using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;
using Indotalent.Data.Enums;
using Indotalent.ConfigBackEnd.Extensions;

namespace Indotalent.Features.Sales.SalesQuotation.Cqrs;

public class SalesQuotationLookupResponse
{
    public List<LookupItem> Customers { get; set; } = new();
    public List<LookupItem> Taxes { get; set; } = new();
    public List<LookupItem> Products { get; set; } = new();
    public List<LookupStatusItem> Statuses { get; set; } = new();
}

public class LookupItem
{
    public string? Id { get; set; }
    public string? Name { get; set; }
}

public class LookupStatusItem
{
    public int Value { get; set; }
    public string? Name { get; set; }
}

public record GetSalesQuotationLookupQuery() : IRequest<SalesQuotationLookupResponse>;

public class GetSalesQuotationLookupHandler : IRequestHandler<GetSalesQuotationLookupQuery, SalesQuotationLookupResponse>
{
    private readonly AppDbContext _context;
    public GetSalesQuotationLookupHandler(AppDbContext context) => _context = context;

    public async Task<SalesQuotationLookupResponse> Handle(GetSalesQuotationLookupQuery request, CancellationToken cancellationToken)
    {
        var response = new SalesQuotationLookupResponse();

        response.Customers = await _context.Customer.AsNoTracking()
            .OrderBy(x => x.Name)
            .Select(x => new LookupItem
            {
                Id = x.Id,
                Name = x.Name
            })
            .ToListAsync(cancellationToken);

        response.Taxes = await _context.Tax.AsNoTracking()
            .OrderBy(x => x.Name)
            .Select(x => new LookupItem
            {
                Id = x.Id,
                Name = x.Name
            })
            .ToListAsync(cancellationToken);

        response.Products = await _context.Product.AsNoTracking()
            .OrderBy(x => x.Name)
            .Select(x => new LookupItem
            {
                Id = x.Id,
                Name = x.Name
            })
            .ToListAsync(cancellationToken);

        response.Statuses = Enum.GetValues(typeof(SalesQuotationStatus))
            .Cast<SalesQuotationStatus>()
            .Select(x => new LookupStatusItem
            {
                Value = (int)x,
                Name = x.GetDescription()
            }).ToList();

        return response;
    }
}